
Robotics Systems Types - Bug #1241
Linking against rst-converters fails on Win7
11/17/2012 07:39 PM - V. Losing

Status: Resolved Start date: 11/17/2012
Priority: Normal Due date:
Assignee: J. Wienke % Done: 100%
Category: cpp Estimated time: 0.00 hour
Target version: rsb-0.7
Description

I didn't find the rst-converter-Project so I post the issue here.

When I compile against rst-converters and use rst::converters::opencv::IplImageConverter::IplImageDeleter() I get a linking error.
class __declspec(dllexport) is missing for the class IplImageDeleter (I've fixed it locally, but it's better to fix it for others too).

Associated revisions
Revision 5a6ecfc4 - 11/17/2012 09:55 PM - J. Moringen

Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h

refs #1241

The project was missing __declspec(dllimport) declarations for classes
and this produced an unused dll in Windows.

    -  cpp/CMakeLists.txt: define RST_CONVERTERS_EXPORT with
  __declspec(dllimport) on Windows

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: added
  RST_CONVERTERS_EXPORT to class definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise
    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h: likewise

Revision 1810f615 - 11/17/2012 09:55 PM - J. Moringen

Backport: Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h

fixes #1241

The project was missing __declspec(dllimport) declarations for classes
and this produced an unused dll in Windows.
    -  cpp/CMakeLists.txt: define RST_CONVERTERS_EXPORT with
  __declspec(dllimport) on Windows

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: added
  RST_CONVERTERS_EXPORT to class definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise
    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h: likewise

Revision 15c77781 - 11/17/2012 11:40 PM - J. Moringen

Backport: Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h

fixes #1241

The project was missing __declspec(dll{import,export}) declarations
for classes and this produced an unused dll in Windows.

    -  cpp/src/CMakeLists.txt: configure file and install file
  rstconvertersexorts.h

    -  cpp/src/rst/rstconvertersexports.h.in: new file; is configured to
  produce appropriate value of RST_CONVERTERS_EXPORT

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: include
  rstconvertersexports.h; add RST_CONVERTERS_EXPORT to class
  definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise
    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h:

  likewise

Revision bfd7955f - 11/17/2012 11:40 PM - J. Moringen

Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h
refs #1241

The project was missing __declspec(dll{import,export}) declarations
for classes and this produced an unused dll in Windows.

    -  cpp/src/CMakeLists.txt: configure file and install file
  rstconvertersexorts.h

    -  cpp/src/rst/rstconvertersexports.h.in: new file; is configured to
  produce appropriate value of RST_CONVERTERS_EXPORT

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: include
  rstconvertersexports.h; add RST_CONVERTERS_EXPORT to class
  definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise
    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h:

  likewise

Revision cf0b9053 - 11/17/2012 11:40 PM - J. Moringen

Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h

refs #1241

The project was missing __declspec(dll{import,export}) declarations
for classes and this produced an unused dll in Windows.

    -  cpp/src/CMakeLists.txt: configure file and install file
  rstconvertersexorts.h

    -  cpp/src/rst/rstconvertersexports.h.in: new file; is configured to
  produce appropriate value of RST_CONVERTERS_EXPORT

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: include
  rstconvertersexports.h; add RST_CONVERTERS_EXPORT to class
  definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise

04/28/2024 3/9



    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h:

  likewise

Revision b9c310cd - 11/17/2012 11:40 PM - J. Moringen

Added RST_CONVERTERS_EXPORT in cpp/CMakeLists.txt, */.h

refs #1241

The project was missing __declspec(dll{import,export}) declarations
for classes and this produced an unused dll in Windows.

    -  cpp/src/CMakeLists.txt: configure file and install file
  rstconvertersexorts.h

    -  cpp/src/rst/rstconvertersexports.h.in: new file; is configured to
  produce appropriate value of RST_CONVERTERS_EXPORT

    -  cpp/src/rst/converters/boost/TransformationPoseConverter.h: include
  rstconvertersexports.h; add RST_CONVERTERS_EXPORT to class
  definitions

    -  cpp/src/rst/converters/boost/TwoDPoseConverter.h: likewise
    -  cpp/src/rst/converters/naoqi/ALImageConverter.h: likewise
    -  cpp/src/rst/converters/opencv/IplImageConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointAnglesConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointImpedanceConverter.h: likewise
    -  cpp/src/rst/converters/rci/JointTorquesConverter.h: likewise
    -  cpp/src/rst/converters/rci/LengthConverter.h: likewise
    -  cpp/src/rst/converters/rci/PhaseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PoseConverter.h: likewise
    -  cpp/src/rst/converters/rci/PressureConverter.h: likewise
    -  cpp/src/rst/converters/rci/TranslationConverter.h: likewise
    -  cpp/src/rst/converters/surfimageconverter/SurfImageConverter.h:

  likewise

Revision 5a8b2241 - 11/27/2012 05:33 PM - J. Wienke

Add a windows build batch file.

refs #1241

Revision 7309d207 - 11/27/2012 05:33 PM - J. Wienke

Add a windows build batch file.

refs #1241

Revision e8a0f929 - 11/27/2012 05:33 PM - J. Wienke

Add a windows build batch file.
refs #1241

Revision 110322c8 - 11/28/2012 11:40 AM - J. Wienke

Avoid compilation errors on windows.
The preprocessor does not like symbols with a minus character in their name. Therefore:
    -  CMakeListst.txt:
        -  rename rst-converters to rstconverters to avoid minus character
        -  add a warning if still a minus characters is found which could be induced through the customization option
    -  src/rst/rstconvertersexports.h.in: Use #pragma once instead of old include guards

refs #1241

Revision 77ffb2ea - 11/28/2012 11:40 AM - J. Wienke

Avoid compilation errors on windows.
The preprocessor does not like symbols with a minus character in their name. Therefore:
    -  CMakeListst.txt:
        -  rename rst-converters to rstconverters to avoid minus character
        -  add a warning if still a minus characters is found which could be induced through the customization option
    -  src/rst/rstconvertersexports.h.in: Use #pragma once instead of old include guards

refs #1241

Revision 23469f9f - 11/28/2012 11:40 AM - J. Wienke

Avoid compilation errors on windows.
The preprocessor does not like symbols with a minus character in their name. Therefore:
    -  CMakeListst.txt:
        -  rename rst-converters to rstconverters to avoid minus character
        -  add a warning if still a minus characters is found which could be induced through the customization option
    -  src/rst/rstconvertersexports.h.in: Use #pragma once instead of old include guards

refs #1241

Revision 86cc4390 - 11/28/2012 11:52 AM - J. Wienke

Properly include time for windows.

refs #1241

Revision a1fd91e8 - 11/28/2012 11:52 AM - J. Wienke

Properly include time for windows.

refs #1241
Revision e9649ee2 - 11/28/2012 11:52 AM - J. Wienke

Properly include time for windows.

refs #1241

Revision fd42a0b7 - 11/28/2012 06:07 PM - J. Wienke

Backport: Add a windows build batch file.

refs #1241

Revision e6412444 - 11/28/2012 06:08 PM - J. Wienke

Backport: Avoid compilation errors on windows.
The preprocessor does not like symbols with a minus character in their name. Therefore:
    -  CMakeListst.txt:
        -  rename rst-converters to rstconverters to avoid minus character
        -  add a warning if still a minus characters is found which could be induced through the customization option
    -  src/rst/rstconvertersexports.h.in: Use #pragma once instead of old include guards

refs #1241

Revision 4fa72715 - 11/28/2012 06:09 PM - J. Wienke

Backport: Properly include time for windows.

refs #1241

History
#1 - 11/17/2012 09:19 PM - J. Moringen
- Project changed from Robotics Service Bus to Robotics Systems Types
- Category set to cpp
- Status changed from New to In Progress
- Assignee set to J. Moringen
- Target version set to rsb-0.7

#2 - 11/17/2012 10:02 PM - J. Moringen
- Status changed from In Progress to Resolved
- % Done changed from 0 to 100

Applied in changeset rst-converters|commit:1810f6152cb4dba586ea733bd100a9c80eaf0538.

#3 - 11/17/2012 10:04 PM - J. Moringen

I tried to solve this without actually testing on Windows. Reopen, if the problem persists.
#4 - 11/17/2012 10:11 PM - J. Moringen
- Status changed from Resolved to In Progress

I don't think, the fix is correct. I will try to correct it later.

#5 - 11/17/2012 11:41 PM - J. Moringen
- Status changed from In Progress to Resolved

Applied in changeset rst-converters|commit:15c777819c4440939ef37187452e33c7d7e74f9c.

#6 - 11/21/2012 12:50 PM - J. Moringen

@Viktor: did you try the fix?

#7 - 11/27/2012 11:42 AM - V. Losing

Yes i tried it, but i can't even compile the converters anymore. Seems there is a problem with the macro rst_converters_export.... that's the compiler
message i get:

2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): error C2004: expected 'defined(id)'
2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): fatal error C1012: unmatched parenthesis : missing ')'
2>  TransformationPoseConverter.cpp
2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): error C2004: expected 'defined(id)'
2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): fatal error C1012: unmatched parenthesis : missing ')'
2>  TwoDPoseConverter.cpp
2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): error C2004: expected 'defined(id)'
2>C:\test\Building\debug\myconverters2\cpp\build\src\rst/rstconvertersexports.h(34): fatal error C1012: unmatched parenthesis : missing ')'
2>  Generating Code...

#8 - 11/27/2012 12:20 PM - J. Moringen
- Status changed from Resolved to In Progress
- Assignee deleted (J. Moringen)

@Johannes: can you have a look? I don't have the patience for this stuff.

#9 - 11/27/2012 12:22 PM - J. Wienke

@Jan: From a rough look I don't see a problem. However, can you first fix the trunk build so that I have a basis for further testing? ;) On Linux it is
broken, too due to plugin changes.

#10 - 11/27/2012 01:27 PM - J. Moringen

rst-converters-trunk builds again
#11 - 11/27/2012 05:43 PM - V. Losing

could you please fix it in the isy-project repository too ?
https://isyprojects.techfak.uni-bielefeld.de/isy-svn/rst/rst-converters

#12 - 11/27/2012 05:45 PM - J. Wienke

In the end we can generate a patch, which will be easy to apply to the rst-converters there.

#13 - 11/27/2012 05:47 PM - J. Wienke
- Assignee set to J. Wienke

#14 - 11/27/2012 07:31 PM - J. Wienke
- % Done changed from 100 to 60

Ok, after some upstream fixes we now have a job on the CI server (for trunk though) to reproduce the problem. Now we can work on a fix in a reliable
way.

#15 - 11/28/2012 11:28 AM - J. Wienke

So, the error does not appear if I change the libraryname from rst-converters to rstconverters. Any minus in the name results in the visible error. It
seems that windows doesn't like minus characters in preprocessor symbol names and sometimes interprets them as a mathematical operator. Hence,
we need to change the library name, which is not so nice, because for the 0.7 release it changes the external interface of the library.

@Jan: Should I add a logic which removes the - only on windows for 0.7 to preserve the interface?

#16 - 11/28/2012 06:36 PM - J. Wienke
- % Done changed from 60 to 80

Viktor, I have backported the changes to the official 0.7 branch of rst-converters. Can you please once test whether this works now for you? If so, I will
port these changes also to the ISY branch.

#17 - 11/29/2012 10:17 AM - V. Losing

Works for me now. Good job!

#18 - 11/29/2012 10:41 AM - J. Wienke
- % Done changed from 80 to 90

Great, I have merged the changes to the isy SVN version. Can your try this once again. Afterwards, I can close this issue.

#19 - 12/04/2012 11:43 AM - J. Wienke
ping

#20 - 12/10/2012 03:19 PM - V. Losing

Works there, too :D

#21 - 12/10/2012 03:25 PM - J. Wienke
- Status changed from In Progress to Resolved
- % Done changed from 90 to 100
